import os
import sys


sys.path.append(os.getcwd())
from video_capture.douyin.douyin_author.douyin_author import douyinAuthor
from video_stitching.video_stitching import VideoStitching
import schedule
import time

def job_video_stitching():
    VideoStitching.video_cookie()

def job_douyin_data():
    douyinAuthor.get_token()

# 设置上午10点运行任务
schedule.every().day.at("14:00").do(job_douyin_data)

# 设置下午4点运行任务
schedule.every().day.at("10:08").do(job_video_stitching)

while True:
    schedule.run_pending()
    time.sleep(1)



